// -*-c++-*-
/* This file was automatically generated by rpcc. */

#include "nfs_prot.h"

#ifdef MAINTAINER

const strbuf &
rpc_print (const strbuf &sb, const nfsstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case NFS_OK:
    p = "NFS_OK";
    break;
  case NFSERR_PERM:
    p = "NFSERR_PERM";
    break;
  case NFSERR_NOENT:
    p = "NFSERR_NOENT";
    break;
  case NFSERR_IO:
    p = "NFSERR_IO";
    break;
  case NFSERR_NXIO:
    p = "NFSERR_NXIO";
    break;
  case NFSERR_ACCES:
    p = "NFSERR_ACCES";
    break;
  case NFSERR_EXIST:
    p = "NFSERR_EXIST";
    break;
  case NFSERR_NODEV:
    p = "NFSERR_NODEV";
    break;
  case NFSERR_NOTDIR:
    p = "NFSERR_NOTDIR";
    break;
  case NFSERR_ISDIR:
    p = "NFSERR_ISDIR";
    break;
  case NFSERR_FBIG:
    p = "NFSERR_FBIG";
    break;
  case NFSERR_NOSPC:
    p = "NFSERR_NOSPC";
    break;
  case NFSERR_ROFS:
    p = "NFSERR_ROFS";
    break;
  case NFSERR_NAMETOOLONG:
    p = "NFSERR_NAMETOOLONG";
    break;
  case NFSERR_NOTEMPTY:
    p = "NFSERR_NOTEMPTY";
    break;
  case NFSERR_DQUOT:
    p = "NFSERR_DQUOT";
    break;
  case NFSERR_STALE:
    p = "NFSERR_STALE";
    break;
  case NFSERR_WFLUSH:
    p = "NFSERR_WFLUSH";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "nfsstat " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_nfsstat (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<nfsstat *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const ftype &obj, int recdepth,
           const char *name, const char *prefix)
{
  char *p;
  switch (obj) {
  case NFNON:
    p = "NFNON";
    break;
  case NFREG:
    p = "NFREG";
    break;
  case NFDIR:
    p = "NFDIR";
    break;
  case NFBLK:
    p = "NFBLK";
    break;
  case NFCHR:
    p = "NFCHR";
    break;
  case NFLNK:
    p = "NFLNK";
    break;
  case NFSOCK:
    p = "NFSOCK";
    break;
  case NFBAD:
    p = "NFBAD";
    break;
  case NFFIFO:
    p = "NFFIFO";
    break;
  default:
    p = NULL;
    break;
  }
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "ftype " << name << " = ";
  };
  if (p)
    sb << p;
  else
    sb << int (obj);
  if (prefix)
    sb << ";\n";
  return sb;
};
void
print_ftype (const void *_objp, const strbuf *_sbp, int _recdepth,
             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<ftype *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const nfs_fh &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "nfs_fh " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.data, recdepth, "data", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_nfs_fh (const void *_objp, const strbuf *_sbp, int _recdepth,
              const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<nfs_fh *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const nfstime &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "nfstime " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.seconds, recdepth, "seconds", npref);
  sb << sep;
  rpc_print (sb, obj.useconds, recdepth, "useconds", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_nfstime (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<nfstime *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const fattr &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "fattr " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.type, recdepth, "type", npref);
  sb << sep;
  rpc_print (sb, obj.mode, recdepth, "mode", npref);
  sb << sep;
  rpc_print (sb, obj.nlink, recdepth, "nlink", npref);
  sb << sep;
  rpc_print (sb, obj.uid, recdepth, "uid", npref);
  sb << sep;
  rpc_print (sb, obj.gid, recdepth, "gid", npref);
  sb << sep;
  rpc_print (sb, obj.size, recdepth, "size", npref);
  sb << sep;
  rpc_print (sb, obj.blocksize, recdepth, "blocksize", npref);
  sb << sep;
  rpc_print (sb, obj.rdev, recdepth, "rdev", npref);
  sb << sep;
  rpc_print (sb, obj.blocks, recdepth, "blocks", npref);
  sb << sep;
  rpc_print (sb, obj.fsid, recdepth, "fsid", npref);
  sb << sep;
  rpc_print (sb, obj.fileid, recdepth, "fileid", npref);
  sb << sep;
  rpc_print (sb, obj.atime, recdepth, "atime", npref);
  sb << sep;
  rpc_print (sb, obj.mtime, recdepth, "mtime", npref);
  sb << sep;
  rpc_print (sb, obj.ctime, recdepth, "ctime", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_fattr (const void *_objp, const strbuf *_sbp, int _recdepth,
             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<fattr *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const sattr &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sattr " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.mode, recdepth, "mode", npref);
  sb << sep;
  rpc_print (sb, obj.uid, recdepth, "uid", npref);
  sb << sep;
  rpc_print (sb, obj.gid, recdepth, "gid", npref);
  sb << sep;
  rpc_print (sb, obj.size, recdepth, "size", npref);
  sb << sep;
  rpc_print (sb, obj.atime, recdepth, "atime", npref);
  sb << sep;
  rpc_print (sb, obj.mtime, recdepth, "mtime", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sattr (const void *_objp, const strbuf *_sbp, int _recdepth,
             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<sattr *> (_objp),
             _recdepth, _name, _prefix);
}

void
print_filename (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<filename *> (_objp),
             _recdepth, _name, _prefix);
}

void
print_nfspath (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<nfspath *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const attrstat &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "attrstat " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case NFS_OK:
    sb << sep;
    rpc_print (sb, *obj.attributes,  recdepth, "attributes", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_attrstat (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<attrstat *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const sattrargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "sattrargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.file, recdepth, "file", npref);
  sb << sep;
  rpc_print (sb, obj.attributes, recdepth, "attributes", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_sattrargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<sattrargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const diropargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "diropargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.dir, recdepth, "dir", npref);
  sb << sep;
  rpc_print (sb, obj.name, recdepth, "name", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_diropargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<diropargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const diropokres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "diropokres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.file, recdepth, "file", npref);
  sb << sep;
  rpc_print (sb, obj.attributes, recdepth, "attributes", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_diropokres (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<diropokres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const diropres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "diropres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case NFS_OK:
    sb << sep;
    rpc_print (sb, *obj.reply,  recdepth, "reply", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_diropres (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<diropres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const readlinkres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "readlinkres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case NFS_OK:
    sb << sep;
    rpc_print (sb, *obj.data,  recdepth, "data", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_readlinkres (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<readlinkres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const readargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "readargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.file, recdepth, "file", npref);
  sb << sep;
  rpc_print (sb, obj.offset, recdepth, "offset", npref);
  sb << sep;
  rpc_print (sb, obj.count, recdepth, "count", npref);
  sb << sep;
  rpc_print (sb, obj.totalcount, recdepth, "totalcount", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_readargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<readargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const readokres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "readokres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.attributes, recdepth, "attributes", npref);
  sb << sep;
  rpc_print (sb, obj.data, recdepth, "data", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_readokres (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<readokres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const readres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "readres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case NFS_OK:
    sb << sep;
    rpc_print (sb, *obj.reply,  recdepth, "reply", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_readres (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<readres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const writeargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "writeargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.file, recdepth, "file", npref);
  sb << sep;
  rpc_print (sb, obj.beginoffset, recdepth, "beginoffset", npref);
  sb << sep;
  rpc_print (sb, obj.offset, recdepth, "offset", npref);
  sb << sep;
  rpc_print (sb, obj.totalcount, recdepth, "totalcount", npref);
  sb << sep;
  rpc_print (sb, obj.data, recdepth, "data", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_writeargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<writeargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const createargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "createargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.where, recdepth, "where", npref);
  sb << sep;
  rpc_print (sb, obj.attributes, recdepth, "attributes", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_createargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<createargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const renameargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "renameargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.from, recdepth, "from", npref);
  sb << sep;
  rpc_print (sb, obj.to, recdepth, "to", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_renameargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<renameargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const linkargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "linkargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.from, recdepth, "from", npref);
  sb << sep;
  rpc_print (sb, obj.to, recdepth, "to", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_linkargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<linkargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const symlinkargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "symlinkargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.from, recdepth, "from", npref);
  sb << sep;
  rpc_print (sb, obj.to, recdepth, "to", npref);
  sb << sep;
  rpc_print (sb, obj.attributes, recdepth, "attributes", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_symlinkargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<symlinkargs *> (_objp),
             _recdepth, _name, _prefix);
}

void
print_nfscookie (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<nfscookie *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const readdirargs &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "readdirargs " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.dir, recdepth, "dir", npref);
  sb << sep;
  rpc_print (sb, obj.cookie, recdepth, "cookie", npref);
  sb << sep;
  rpc_print (sb, obj.count, recdepth, "count", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_readdirargs (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<readdirargs *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const entry &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "entry " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.fileid, recdepth, "fileid", npref);
  sb << sep;
  rpc_print (sb, obj.name, recdepth, "name", npref);
  sb << sep;
  rpc_print (sb, obj.cookie, recdepth, "cookie", npref);
  sb << sep;
  rpc_print (sb, obj.nextentry, recdepth, "nextentry", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_entry (const void *_objp, const strbuf *_sbp, int _recdepth,
             const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<entry *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const dirlist &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "dirlist " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.entries, recdepth, "entries", npref);
  sb << sep;
  rpc_print (sb, obj.eof, recdepth, "eof", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_dirlist (const void *_objp, const strbuf *_sbp, int _recdepth,
               const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<dirlist *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const readdirres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "readdirres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case NFS_OK:
    sb << sep;
    rpc_print (sb, *obj.reply,  recdepth, "reply", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_readdirres (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<readdirres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const statfsokres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "statfsokres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.tsize, recdepth, "tsize", npref);
  sb << sep;
  rpc_print (sb, obj.bsize, recdepth, "bsize", npref);
  sb << sep;
  rpc_print (sb, obj.blocks, recdepth, "blocks", npref);
  sb << sep;
  rpc_print (sb, obj.bfree, recdepth, "bfree", npref);
  sb << sep;
  rpc_print (sb, obj.bavail, recdepth, "bavail", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_statfsokres (const void *_objp, const strbuf *_sbp, int _recdepth,
                   const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<statfsokres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const statfsres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "statfsres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case NFS_OK:
    sb << sep;
    rpc_print (sb, *obj.reply,  recdepth, "reply", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_statfsres (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<statfsres *> (_objp),
             _recdepth, _name, _prefix);
}

#endif /* MAINTAINER*/
void *
nfsstat_alloc ()
{
  return New nfsstat;
}
bool_t
xdr_nfsstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<nfsstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<nfsstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
ftype_alloc ()
{
  return New ftype;
}
bool_t
xdr_ftype (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<ftype *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<ftype *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
nfs_fh_alloc ()
{
  return New nfs_fh;
}
bool_t
xdr_nfs_fh (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<nfs_fh *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<nfs_fh *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
nfstime_alloc ()
{
  return New nfstime;
}
bool_t
xdr_nfstime (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<nfstime *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<nfstime *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
fattr_alloc ()
{
  return New fattr;
}
bool_t
xdr_fattr (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<fattr *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<fattr *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sattr_alloc ()
{
  return New sattr;
}
bool_t
xdr_sattr (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sattr *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sattr *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
filename_alloc ()
{
  return New filename;
}
bool_t
xdr_filename (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<filename *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<filename *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
nfspath_alloc ()
{
  return New nfspath;
}
bool_t
xdr_nfspath (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<nfspath *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<nfspath *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
attrstat_alloc ()
{
  return New attrstat;
}
bool_t
xdr_attrstat (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<attrstat *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<attrstat *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
sattrargs_alloc ()
{
  return New sattrargs;
}
bool_t
xdr_sattrargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<sattrargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<sattrargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
diropargs_alloc ()
{
  return New diropargs;
}
bool_t
xdr_diropargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<diropargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<diropargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
diropokres_alloc ()
{
  return New diropokres;
}
bool_t
xdr_diropokres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<diropokres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<diropokres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
diropres_alloc ()
{
  return New diropres;
}
bool_t
xdr_diropres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<diropres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<diropres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
readlinkres_alloc ()
{
  return New readlinkres;
}
bool_t
xdr_readlinkres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<readlinkres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<readlinkres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
readargs_alloc ()
{
  return New readargs;
}
bool_t
xdr_readargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<readargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<readargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
readokres_alloc ()
{
  return New readokres;
}
bool_t
xdr_readokres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<readokres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<readokres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
readres_alloc ()
{
  return New readres;
}
bool_t
xdr_readres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<readres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<readres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
writeargs_alloc ()
{
  return New writeargs;
}
bool_t
xdr_writeargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<writeargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<writeargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
createargs_alloc ()
{
  return New createargs;
}
bool_t
xdr_createargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<createargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<createargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
renameargs_alloc ()
{
  return New renameargs;
}
bool_t
xdr_renameargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<renameargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<renameargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
linkargs_alloc ()
{
  return New linkargs;
}
bool_t
xdr_linkargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<linkargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<linkargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
symlinkargs_alloc ()
{
  return New symlinkargs;
}
bool_t
xdr_symlinkargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<symlinkargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<symlinkargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
nfscookie_alloc ()
{
  return New nfscookie;
}
bool_t
xdr_nfscookie (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<nfscookie *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<nfscookie *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
readdirargs_alloc ()
{
  return New readdirargs;
}
bool_t
xdr_readdirargs (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<readdirargs *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<readdirargs *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
entry_alloc ()
{
  return New entry;
}
bool_t
xdr_entry (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<entry *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<entry *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
dirlist_alloc ()
{
  return New dirlist;
}
bool_t
xdr_dirlist (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<dirlist *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<dirlist *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
readdirres_alloc ()
{
  return New readdirres;
}
bool_t
xdr_readdirres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<readdirres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<readdirres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
statfsokres_alloc ()
{
  return New statfsokres;
}
bool_t
xdr_statfsokres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<statfsokres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<statfsokres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
statfsres_alloc ()
{
  return New statfsres;
}
bool_t
xdr_statfsres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<statfsres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<statfsres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

static const rpcgen_table nfs_program_2_tbl[] = {
  NFS_PROGRAM_2_APPLY (XDRTBL_DECL)
};
const rpc_program nfs_program_2 = {
  NFS_PROGRAM, NFS_VERSION, nfs_program_2_tbl,
  sizeof (nfs_program_2_tbl) / sizeof (nfs_program_2_tbl[0]),
  "nfs_program_2"
};


