// -*-c++-*-
/* This file was automatically generated by rpcc. */

#include "nfsmounter.h"

#ifdef MAINTAINER

void
print_nfsmnt_handle (const void *_objp, const strbuf *_sbp, int _recdepth,
                     const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<nfsmnt_handle *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const mountarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "mountarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.hostname, recdepth, "hostname", npref);
  sb << sep;
  rpc_print (sb, obj.path, recdepth, "path", npref);
  sb << sep;
  rpc_print (sb, obj.flags, recdepth, "flags", npref);
  sb << sep;
  rpc_print (sb, obj.handle, recdepth, "handle", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_mountarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<mountarg *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const mountres &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "mountres " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.status, recdepth, "status", npref);
  switch (obj.status) {
  case 0:
    sb << sep;
    rpc_print (sb, *obj.fsid,  recdepth, "fsid", npref);
    break;
  default:
    break;
  }
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_mountres (const void *_objp, const strbuf *_sbp, int _recdepth,
                const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<mountres *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const remountarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "remountarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.path, recdepth, "path", npref);
  sb << sep;
  rpc_print (sb, obj.flags, recdepth, "flags", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_remountarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                  const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<remountarg *> (_objp),
             _recdepth, _name, _prefix);
}

const strbuf &
rpc_print (const strbuf &sb, const umountarg &obj, int recdepth,
           const char *name, const char *prefix)
{
  if (name) {
    if (prefix)
      sb << prefix;
    sb << "umountarg " << name << " = ";
  };
  const char *sep;
  str npref;
  if (prefix) {
    npref = strbuf ("%s  ", prefix);
    sep = "";
    sb << "{\n";
  }
  else {
    sep = ", ";
    sb << "{ ";
  }
  rpc_print (sb, obj.path, recdepth, "path", npref);
  sb << sep;
  rpc_print (sb, obj.flags, recdepth, "flags", npref);
  if (prefix)
    sb << prefix << "};\n";
  else
    sb << " }";
  return sb;
}
void
print_umountarg (const void *_objp, const strbuf *_sbp, int _recdepth,
                 const char *_name, const char *_prefix)
{
  rpc_print (_sbp ? *_sbp : warnx, *static_cast<umountarg *> (_objp),
             _recdepth, _name, _prefix);
}

#endif /* MAINTAINER*/
void *
nfsmnt_handle_alloc ()
{
  return New nfsmnt_handle;
}
bool_t
xdr_nfsmnt_handle (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<nfsmnt_handle *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<nfsmnt_handle *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
mountarg_alloc ()
{
  return New mountarg;
}
bool_t
xdr_mountarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<mountarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<mountarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
mountres_alloc ()
{
  return New mountres;
}
bool_t
xdr_mountres (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<mountres *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<mountres *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
remountarg_alloc ()
{
  return New remountarg;
}
bool_t
xdr_remountarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<remountarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<remountarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

void *
umountarg_alloc ()
{
  return New umountarg;
}
bool_t
xdr_umountarg (XDR *xdrs, void *objp)
{
  switch (xdrs->x_op) {
  case XDR_ENCODE:
  case XDR_DECODE:
    return rpc_traverse (xdrs, *static_cast<umountarg *> (objp));
  case XDR_FREE:
    rpc_destruct (static_cast<umountarg *> (objp));
    return true;
  default:
    panic ("invalid xdr operation %d\n", xdrs->x_op);
  }
}

static const rpcgen_table nfsmounter_prog_1_tbl[] = {
  NFSMOUNTER_PROG_1_APPLY (XDRTBL_DECL)
};
const rpc_program nfsmounter_prog_1 = {
  NFSMOUNTER_PROG, NFSMOUNTER_VERS, nfsmounter_prog_1_tbl,
  sizeof (nfsmounter_prog_1_tbl) / sizeof (nfsmounter_prog_1_tbl[0]),
  "nfsmounter_prog_1"
};


